
<!DOCTYPE html>

<html>
  <head>
    <meta charset="utf-8" />
    <meta name="viewport" content="width=device-width, initial-scale=1.0" />
    <title>Normalisation Training Colab &#8212; Battery SOH 2022 documentation</title>
    
  <link href="../_static/css/theme.css" rel="stylesheet" />
  <link href="../_static/css/index.c5995385ac14fb8791e8eb36b4908be2.css" rel="stylesheet" />

    
  <link rel="stylesheet"
    href="../_static/vendor/fontawesome/5.13.0/css/all.min.css">
  <link rel="preload" as="font" type="font/woff2" crossorigin
    href="../_static/vendor/fontawesome/5.13.0/webfonts/fa-solid-900.woff2">
  <link rel="preload" as="font" type="font/woff2" crossorigin
    href="../_static/vendor/fontawesome/5.13.0/webfonts/fa-brands-400.woff2">

    
      

    
    <link rel="stylesheet" type="text/css" href="../_static/pygments.css" />
    <link rel="stylesheet" type="text/css" href="../_static/basic.css" />
    
  <link rel="preload" as="script" href="../_static/js/index.1c5a1a01449ed65a7b51.js">

    <script data-url_root="../" id="documentation_options" src="../_static/documentation_options.js"></script>
    <script src="../_static/jquery.js"></script>
    <script src="../_static/underscore.js"></script>
    <script src="../_static/doctools.js"></script>
    <script crossorigin="anonymous" integrity="sha256-Ae2Vz/4ePdIu6ZyI/5ZGsYnb+m0JlOmKPjt6XZ9JJkA=" src="https://cdnjs.cloudflare.com/ajax/libs/require.js/2.3.4/require.min.js"></script>
    <link rel="index" title="Index" href="../genindex.html" />
    <link rel="search" title="Search" href="../search.html" />
    <link rel="next" title="LSTM Chemistry Training Colab" href="lstm_chemistry_training.html" />
    <link rel="prev" title="Training Colab" href="training_colab.html" />
    <meta name="viewport" content="width=device-width, initial-scale=1" />
    <meta name="docsearch:language" content="en" />
    
  </head>
  <body data-spy="scroll" data-target="#bd-toc-nav" data-offset="80">
    
    <div class="container-fluid" id="banner"></div>

    
    <nav class="navbar navbar-light navbar-expand-lg bg-light fixed-top bd-navbar" id="navbar-main"><div class="container-xl">

  <div id="navbar-start">
    
    

<a class="navbar-brand" href="../index.html">
  <img src="../_static/logo.png" class="logo" alt="logo">
</a>


    
  </div>

  <button class="navbar-toggler" type="button" data-toggle="collapse" data-target="#navbar-collapsible" aria-controls="navbar-collapsible" aria-expanded="false" aria-label="Toggle navigation">
    <span class="navbar-toggler-icon"></span>
  </button>

  
  <div id="navbar-collapsible" class="col-lg-9 collapse navbar-collapse">
    <div id="navbar-center" class="mr-auto">
      
      <div class="navbar-center-item">
        <ul id="navbar-main-elements" class="navbar-nav">
    <li class="toctree-l1 current active nav-item">
 <a class="reference internal nav-link" href="Colabs.html">
  Google Colabs
 </a>
</li>

<li class="toctree-l1 nav-item">
 <a class="reference internal nav-link" href="main.html">
  Useful dictionaries
 </a>
</li>

<li class="toctree-l1 nav-item">
 <a class="reference internal nav-link" href="Battery%20Classes.html">
  Battery Classes
 </a>
</li>

<li class="toctree-l1 nav-item">
 <a class="reference internal nav-link" href="Cleaning.html">
  Treatment functions
 </a>
</li>

<li class="toctree-l1 nav-item">
 <a class="reference internal nav-link" href="Models.html">
  Models
 </a>
</li>

<li class="toctree-l1 nav-item">
 <a class="reference internal nav-link" href="Training.html">
  Training and Simulation
 </a>
</li>

<li class="toctree-l1 nav-item">
 <a class="reference internal nav-link" href="Report.html">
  Report related
 </a>
</li>

    
</ul>
      </div>
      
    </div>

    <div id="navbar-end">
      
      <div class="navbar-end-item">
        <ul id="navbar-icon-links" class="navbar-nav" aria-label="Icon Links">
      </ul>
      </div>
      
    </div>
  </div>
</div>
    </nav>
    

    <div class="container-xl">
      <div class="row">
          
            
            <!-- Only show if we have sidebars configured, else just a small margin  -->
            <div class="col-12 col-md-3 bd-sidebar"><form class="bd-search d-flex align-items-center" action="../search.html" method="get">
  <i class="icon fas fa-search"></i>
  <input type="search" class="form-control" name="q" id="search-input" placeholder="Search the docs ..." aria-label="Search the docs ..." autocomplete="off" >
</form><nav class="bd-links" id="bd-docs-nav" aria-label="Main navigation">
  <div class="bd-toc-item active">
    <p class="caption">
 <span class="caption-text">
  Contents:
 </span>
</p>
<ul class="current nav bd-sidenav">
 <li class="toctree-l1">
  <a class="reference internal" href="training_colab.html">
   Training Colab
  </a>
 </li>
 <li class="toctree-l1 current active">
  <a class="current reference internal" href="#">
   Normalisation Training
  </a>
 </li>
 <li class="toctree-l1">
  <a class="reference internal" href="lstm_chemistry_training.html">
   LSTM Chemistry Training
  </a>
 </li>
</ul>

  </div>
</nav>
            </div>
            
          

          
          <div class="d-none d-xl-block col-xl-2 bd-toc">
            
              
              <div class="toc-item">
                

<nav id="bd-toc-nav">
    
</nav>
              </div>
              
              <div class="toc-item">
                
              </div>
              
            
          </div>
          

          
          
            
          
          <main class="col-12 col-md-9 col-xl-7 py-md-5 pl-md-5 pr-md-4 bd-content" role="main">
              
              <div>
                
  
<style>
/* CSS for nbsphinx extension */

/* remove conflicting styling from Sphinx themes */
div.nbinput.container div.prompt *,
div.nboutput.container div.prompt *,
div.nbinput.container div.input_area pre,
div.nboutput.container div.output_area pre,
div.nbinput.container div.input_area .highlight,
div.nboutput.container div.output_area .highlight {
    border: none;
    padding: 0;
    margin: 0;
    box-shadow: none;
}

div.nbinput.container > div[class*=highlight],
div.nboutput.container > div[class*=highlight] {
    margin: 0;
}

div.nbinput.container div.prompt *,
div.nboutput.container div.prompt * {
    background: none;
}

div.nboutput.container div.output_area .highlight,
div.nboutput.container div.output_area pre {
    background: unset;
}

div.nboutput.container div.output_area div.highlight {
    color: unset;  /* override Pygments text color */
}

/* avoid gaps between output lines */
div.nboutput.container div[class*=highlight] pre {
    line-height: normal;
}

/* input/output containers */
div.nbinput.container,
div.nboutput.container {
    display: -webkit-flex;
    display: flex;
    align-items: flex-start;
    margin: 0;
    width: 100%;
}
@media (max-width: 540px) {
    div.nbinput.container,
    div.nboutput.container {
        flex-direction: column;
    }
}

/* input container */
div.nbinput.container {
    padding-top: 5px;
}

/* last container */
div.nblast.container {
    padding-bottom: 5px;
}

/* input prompt */
div.nbinput.container div.prompt pre {
    color: #307FC1;
}

/* output prompt */
div.nboutput.container div.prompt pre {
    color: #BF5B3D;
}

/* all prompts */
div.nbinput.container div.prompt,
div.nboutput.container div.prompt {
    width: 4.5ex;
    padding-top: 5px;
    position: relative;
    user-select: none;
}

div.nbinput.container div.prompt > div,
div.nboutput.container div.prompt > div {
    position: absolute;
    right: 0;
    margin-right: 0.3ex;
}

@media (max-width: 540px) {
    div.nbinput.container div.prompt,
    div.nboutput.container div.prompt {
        width: unset;
        text-align: left;
        padding: 0.4em;
    }
    div.nboutput.container div.prompt.empty {
        padding: 0;
    }

    div.nbinput.container div.prompt > div,
    div.nboutput.container div.prompt > div {
        position: unset;
    }
}

/* disable scrollbars on prompts */
div.nbinput.container div.prompt pre,
div.nboutput.container div.prompt pre {
    overflow: hidden;
}

/* input/output area */
div.nbinput.container div.input_area,
div.nboutput.container div.output_area {
    -webkit-flex: 1;
    flex: 1;
    overflow: auto;
}
@media (max-width: 540px) {
    div.nbinput.container div.input_area,
    div.nboutput.container div.output_area {
        width: 100%;
    }
}

/* input area */
div.nbinput.container div.input_area {
    border: 1px solid #e0e0e0;
    border-radius: 2px;
    /*background: #f5f5f5;*/
}

/* override MathJax center alignment in output cells */
div.nboutput.container div[class*=MathJax] {
    text-align: left !important;
}

/* override sphinx.ext.imgmath center alignment in output cells */
div.nboutput.container div.math p {
    text-align: left;
}

/* standard error */
div.nboutput.container div.output_area.stderr {
    background: #fdd;
}

/* ANSI colors */
.ansi-black-fg { color: #3E424D; }
.ansi-black-bg { background-color: #3E424D; }
.ansi-black-intense-fg { color: #282C36; }
.ansi-black-intense-bg { background-color: #282C36; }
.ansi-red-fg { color: #E75C58; }
.ansi-red-bg { background-color: #E75C58; }
.ansi-red-intense-fg { color: #B22B31; }
.ansi-red-intense-bg { background-color: #B22B31; }
.ansi-green-fg { color: #00A250; }
.ansi-green-bg { background-color: #00A250; }
.ansi-green-intense-fg { color: #007427; }
.ansi-green-intense-bg { background-color: #007427; }
.ansi-yellow-fg { color: #DDB62B; }
.ansi-yellow-bg { background-color: #DDB62B; }
.ansi-yellow-intense-fg { color: #B27D12; }
.ansi-yellow-intense-bg { background-color: #B27D12; }
.ansi-blue-fg { color: #208FFB; }
.ansi-blue-bg { background-color: #208FFB; }
.ansi-blue-intense-fg { color: #0065CA; }
.ansi-blue-intense-bg { background-color: #0065CA; }
.ansi-magenta-fg { color: #D160C4; }
.ansi-magenta-bg { background-color: #D160C4; }
.ansi-magenta-intense-fg { color: #A03196; }
.ansi-magenta-intense-bg { background-color: #A03196; }
.ansi-cyan-fg { color: #60C6C8; }
.ansi-cyan-bg { background-color: #60C6C8; }
.ansi-cyan-intense-fg { color: #258F8F; }
.ansi-cyan-intense-bg { background-color: #258F8F; }
.ansi-white-fg { color: #C5C1B4; }
.ansi-white-bg { background-color: #C5C1B4; }
.ansi-white-intense-fg { color: #A1A6B2; }
.ansi-white-intense-bg { background-color: #A1A6B2; }

.ansi-default-inverse-fg { color: #FFFFFF; }
.ansi-default-inverse-bg { background-color: #000000; }

.ansi-bold { font-weight: bold; }
.ansi-underline { text-decoration: underline; }


div.nbinput.container div.input_area div[class*=highlight] > pre,
div.nboutput.container div.output_area div[class*=highlight] > pre,
div.nboutput.container div.output_area div[class*=highlight].math,
div.nboutput.container div.output_area.rendered_html,
div.nboutput.container div.output_area > div.output_javascript,
div.nboutput.container div.output_area:not(.rendered_html) > img{
    padding: 5px;
    margin: 0;
}

/* fix copybtn overflow problem in chromium (needed for 'sphinx_copybutton') */
div.nbinput.container div.input_area > div[class^='highlight'],
div.nboutput.container div.output_area > div[class^='highlight']{
    overflow-y: hidden;
}

/* hide copybtn icon on prompts (needed for 'sphinx_copybutton') */
.prompt a.copybtn {
    display: none;
}

/* Some additional styling taken form the Jupyter notebook CSS */
div.rendered_html table {
  border: none;
  border-collapse: collapse;
  border-spacing: 0;
  color: black;
  font-size: 12px;
  table-layout: fixed;
}
div.rendered_html thead {
  border-bottom: 1px solid black;
  vertical-align: bottom;
}
div.rendered_html tr,
div.rendered_html th,
div.rendered_html td {
  text-align: right;
  vertical-align: middle;
  padding: 0.5em 0.5em;
  line-height: normal;
  white-space: normal;
  max-width: none;
  border: none;
}
div.rendered_html th {
  font-weight: bold;
}
div.rendered_html tbody tr:nth-child(odd) {
  background: #f5f5f5;
}
div.rendered_html tbody tr:hover {
  background: rgba(66, 165, 245, 0.2);
}
</style>
<div class="section" id="Normalisation-Training-Colab">
<h1><strong>Normalisation Training Colab</strong><a class="headerlink" href="#Normalisation-Training-Colab" title="Permalink to this headline">¶</a></h1>
<p>This Colab serves for training “LSTM_with_norm” models’ normalisation parameters from pre-trained models (found in reports).</p>
<p>The following google drive link corresponds to the most recent project folder(you’ll need to ask for access): <a class="reference external" href="https://drive.google.com/drive/folders/1iZtHF_jrLXeIBbAIk5AXBtS-5Ib6sCQ7?usp=sharing">https://drive.google.com/drive/folders/1iZtHF_jrLXeIBbAIk5AXBtS-5Ib6sCQ7?usp=sharing</a></p>
<p>The following cell includes the bare minimum to mount google drive to google colab so that the files can be directly called. The <code class="docutils literal notranslate"><span class="pre">folder_name</span></code> may have to be updated to the latest <code class="docutils literal notranslate"><span class="pre">Battery_SOH</span></code> folder.</p>
<div class="nbinput docutils container">
<div class="prompt highlight-none notranslate"><div class="highlight"><pre><span></span>[ ]:
</pre></div>
</div>
<div class="input_area highlight-python notranslate"><div class="highlight"><pre>
<span></span><span class="kn">from</span> <span class="nn">google.colab</span> <span class="kn">import</span> <span class="n">drive</span>
<span class="kn">import</span> <span class="nn">os</span>
<span class="kn">import</span> <span class="nn">torch</span> <span class="k">as</span> <span class="nn">th</span>

<span class="c1"># Mounting google drive</span>
<span class="n">drive</span><span class="o">.</span><span class="n">mount</span><span class="p">(</span><span class="s1">&#39;/content/gdrive&#39;</span><span class="p">)</span>
<span class="n">folder_name</span> <span class="o">=</span> <span class="s1">&#39;Battery_SOH_final&#39;</span>
<span class="c1"># The root path will change depending on the latest &#39;bakcup&#39;</span>
<span class="n">root_path</span> <span class="o">=</span> <span class="s1">&#39;gdrive/My Drive/battery_soh/&#39;</span> <span class="o">+</span> <span class="n">folder_name</span>
<span class="n">os</span><span class="o">.</span><span class="n">chdir</span><span class="p">(</span><span class="n">root_path</span><span class="p">)</span>
<span class="n">device</span> <span class="o">=</span> <span class="n">th</span><span class="o">.</span><span class="n">device</span><span class="p">(</span><span class="s1">&#39;cuda:0&#39;</span> <span class="k">if</span> <span class="n">th</span><span class="o">.</span><span class="n">cuda</span><span class="o">.</span><span class="n">is_available</span><span class="p">()</span> <span class="k">else</span> <span class="s1">&#39;cpu&#39;</span><span class="p">)</span>
<span class="n">device</span>
</pre></div>
</div>
</div>
<div class="nboutput docutils container">
<div class="prompt empty docutils container">
</div>
<div class="output_area docutils container">
<div class="highlight"><pre>
Drive already mounted at /content/gdrive; to attempt to forcibly remount, call drive.mount(&#34;/content/gdrive&#34;, force_remount=True).
</pre></div></div>
</div>
<div class="nboutput nblast docutils container">
<div class="prompt empty docutils container">
</div>
<div class="output_area docutils container">
<div class="highlight"><pre>
device(type=&#39;cuda&#39;, index=0)
</pre></div></div>
</div>
<p>The cell should output something like:</p>
<div class="highlight-none notranslate"><div class="highlight"><pre><span></span>Mounted at /content/gdrive
device(type=&#39;cuda&#39;, index=0)
</pre></div>
</div>
<p>If the second line says <code class="docutils literal notranslate"><span class="pre">device(type='cpu')</span></code> then you should change your environment options above for GPU for faster results.</p>
<div class="nbinput docutils container">
<div class="prompt highlight-none notranslate"><div class="highlight"><pre><span></span>[ ]:
</pre></div>
</div>
<div class="input_area highlight-python notranslate"><div class="highlight"><pre>
<span></span># Imports:
# Libraries:
!pip install PyAstronomy
from torch.utils.data import DataLoader, Dataset
from datetime import datetime
import re
import random
import seaborn as sns
sns.set()

# SOH Modules:
# Battery Classes:
from Coin_Classes import *
from MIT_Classes import *
from Nasa_Classes import *
# Models:
from LSTM import *
import LSTM_with_norm as wn #
# Training and Report related:
from Training import *
from Load_Save import *
import DistributionPlots as dp
</pre></div>
</div>
</div>
<div class="nboutput nblast docutils container">
<div class="prompt empty docutils container">
</div>
<div class="output_area docutils container">
<div class="highlight"><pre>
Requirement already satisfied: PyAstronomy in /usr/local/lib/python3.7/dist-packages (0.16.0)
Requirement already satisfied: six in /usr/local/lib/python3.7/dist-packages (from PyAstronomy) (1.15.0)
Requirement already satisfied: numpy in /usr/local/lib/python3.7/dist-packages (from PyAstronomy) (1.19.5)
</pre></div></div>
</div>
<div class="nbinput nblast docutils container">
<div class="prompt highlight-none notranslate"><div class="highlight"><pre><span></span>[ ]:
</pre></div>
</div>
<div class="input_area highlight-python notranslate"><div class="highlight"><pre>
<span></span><span class="c1"># Useful dictionaries:</span>
<span class="kn">import</span> <span class="nn">main</span>

<span class="n">dataset_path_dict</span> <span class="o">=</span> <span class="n">main</span><span class="o">.</span><span class="n">path_dict</span>

<span class="c1"># Batteries to exclude from training and validation datasets:</span>
<span class="n">ignore_dict</span> <span class="o">=</span> <span class="p">{</span>
    <span class="s1">&#39;NASA&#39;</span><span class="p">:</span> <span class="p">[</span><span class="s1">&#39;B0049.txt&#39;</span><span class="p">,</span> <span class="s1">&#39;B0050.txt&#39;</span><span class="p">,</span> <span class="s1">&#39;B0051.txt&#39;</span><span class="p">,</span> <span class="s1">&#39;B0052.txt&#39;</span><span class="p">],</span>
    <span class="s1">&#39;MIT&#39;</span><span class="p">:</span> <span class="p">[</span><span class="s1">&#39;B&#39;</span><span class="o">+</span><span class="nb">str</span><span class="p">(</span><span class="n">i</span><span class="p">)</span><span class="o">.</span><span class="n">zfill</span><span class="p">(</span><span class="mi">4</span><span class="p">)</span><span class="o">+</span><span class="s1">&#39;.txt&#39;</span> <span class="k">for</span> <span class="n">i</span> <span class="ow">in</span> <span class="nb">range</span><span class="p">(</span><span class="mi">15</span><span class="p">,</span> <span class="mi">48</span><span class="p">)],</span>
    <span class="c1"># There are no problems with these ^ batteries, it&#39;s just that MIT&#39;s dataset</span>
    <span class="c1"># is huge, so I don&#39;t include all of the batteries in the validation dataset</span>
    <span class="s1">&#39;Tarascon Coin&#39;</span><span class="p">:</span> <span class="p">[</span><span class="s1">&#39;B0008.txt&#39;</span><span class="p">,</span> <span class="s1">&#39;B0019.txt&#39;</span><span class="p">,</span> <span class="s1">&#39;B0023.txt&#39;</span><span class="p">],</span>
<span class="p">}</span>

<span class="c1"># Batteries to include in the training dataset:</span>
<span class="n">train_dict</span> <span class="o">=</span> <span class="p">{</span>
    <span class="s1">&#39;NASA&#39;</span><span class="p">:</span> <span class="p">[</span><span class="s1">&#39;B0006.txt&#39;</span><span class="p">,</span>
             <span class="s1">&#39;B0030.txt&#39;</span><span class="p">,</span>
             <span class="s1">&#39;B0038.txt&#39;</span><span class="p">,</span>
             <span class="s1">&#39;B0039.txt&#39;</span><span class="p">,</span>
             <span class="s1">&#39;B0041.txt&#39;</span><span class="p">,</span>
             <span class="s1">&#39;B0045.txt&#39;</span><span class="p">,</span>
             <span class="s1">&#39;B0055.txt&#39;</span><span class="p">,],</span> <span class="c1"># 4ºC</span>
    <span class="s1">&#39;MIT&#39;</span><span class="p">:</span> <span class="p">[</span><span class="s1">&#39;B0001.txt&#39;</span><span class="p">],</span>
    <span class="s1">&#39;Tarascon Coin&#39;</span><span class="p">:</span> <span class="p">[</span><span class="s1">&#39;B0001.txt&#39;</span><span class="p">,</span>
                      <span class="s1">&#39;B0004.txt&#39;</span><span class="p">,</span>
                      <span class="s1">&#39;B0014.txt&#39;</span><span class="p">,</span>
                      <span class="s1">&#39;B0016.txt&#39;</span><span class="p">]</span>
<span class="p">}</span>
</pre></div>
</div>
</div>
<div class="nbinput nblast docutils container">
<div class="prompt highlight-none notranslate"><div class="highlight"><pre><span></span>[ ]:
</pre></div>
</div>
<div class="input_area highlight-python notranslate"><div class="highlight"><pre>
<span></span><span class="c1">### Pick the base report:</span>
<span class="n">report_name</span> <span class="o">=</span> <span class="s1">&#39;2021-08-06 09_22_32.468552-nasav4&#39;</span><span class="c1">### (LSTM_v4 trained with NASA)</span>

<span class="c1"># getting the model from the report:</span>
<span class="n">os</span><span class="o">.</span><span class="n">chdir</span><span class="p">(</span><span class="s1">&#39;.//Reports/&#39;</span><span class="o">+</span><span class="n">report_name</span><span class="p">)</span>
<span class="k">with</span> <span class="nb">open</span><span class="p">(</span><span class="s1">&#39;best_model.txt&#39;</span><span class="p">,</span> <span class="s1">&#39;rb&#39;</span><span class="p">)</span> <span class="k">as</span> <span class="n">f</span><span class="p">:</span>
    <span class="n">base_model</span> <span class="o">=</span> <span class="n">pickle</span><span class="o">.</span><span class="n">load</span><span class="p">(</span><span class="n">f</span><span class="p">)</span>
<span class="n">os</span><span class="o">.</span><span class="n">chdir</span><span class="p">(</span><span class="s1">&#39;../../&#39;</span><span class="p">)</span>

<span class="c1"># Setting up a base model from LSTM_with_norm (wn)</span>
<span class="k">if</span> <span class="n">base_model</span><span class="o">.</span><span class="n">version</span> <span class="ow">in</span> <span class="p">[</span><span class="mi">1</span><span class="p">,</span><span class="mi">2</span><span class="p">,</span><span class="mi">3</span><span class="p">]:</span>
    <span class="n">Model</span> <span class="o">=</span> <span class="n">wn</span><span class="o">.</span><span class="n">LSTM_v1</span><span class="p">(</span><span class="mi">10</span><span class="p">,</span> <span class="mi">10</span><span class="p">)</span>
<span class="k">elif</span> <span class="n">base_model</span><span class="o">.</span><span class="n">version</span> <span class="ow">in</span> <span class="p">[</span><span class="mi">4</span><span class="p">,</span><span class="mi">5</span><span class="p">]:</span>
    <span class="n">Model</span> <span class="o">=</span> <span class="n">wn</span><span class="o">.</span><span class="n">LSTM_v4</span><span class="p">(</span><span class="mi">10</span><span class="p">,</span> <span class="mi">10</span><span class="p">)</span>
<span class="k">else</span><span class="p">:</span>
    <span class="k">raise</span> <span class="ne">NameError</span><span class="p">(</span><span class="s2">&quot;Invalid version: &quot;</span><span class="p">,</span> <span class="nb">str</span><span class="p">(</span><span class="n">base_model</span><span class="o">.</span><span class="n">version</span><span class="p">))</span>

<span class="c1"># Copying the report&#39;s model&#39;s parameters</span>
<span class="n">Model</span><span class="o">.</span><span class="n">from_model</span><span class="p">(</span><span class="n">base_model</span><span class="p">)</span>
<span class="n">Model</span> <span class="o">=</span> <span class="n">Model</span><span class="o">.</span><span class="n">to</span><span class="p">(</span><span class="n">device</span><span class="p">)</span>
</pre></div>
</div>
</div>
<div class="nbinput nblast docutils container">
<div class="prompt highlight-none notranslate"><div class="highlight"><pre><span></span>[ ]:
</pre></div>
</div>
<div class="input_area highlight-python notranslate"><div class="highlight"><pre>
<span></span><span class="c1"># initializing dataset related variables:</span>
<span class="n">DELTA</span> <span class="o">=</span> <span class="n">base_model</span><span class="o">.</span><span class="n">delta</span>
<span class="n">LSTM_version</span> <span class="o">=</span> <span class="n">base_model</span><span class="o">.</span><span class="n">version</span>
<span class="n">norm_type</span> <span class="o">=</span> <span class="n">base_model</span><span class="o">.</span><span class="n">norm</span><span class="p">[</span><span class="mi">4</span><span class="p">]</span>

<span class="n">fixed_len</span> <span class="o">=</span> <span class="mi">150</span>         <span class="c1">## Recommended values</span>
<span class="n">time_step</span> <span class="o">=</span> <span class="kc">None</span>        <span class="c1">##</span>
<span class="n">batch_size</span> <span class="o">=</span> <span class="mi">1</span>          <span class="c1">##</span>
<span class="n">adimensionalize</span><span class="o">=</span><span class="kc">True</span>    <span class="c1">##</span>

<span class="n">cycle_lim</span> <span class="o">=</span> <span class="mf">1e6</span>                     <span class="c1">### depends on your analysis</span>
<span class="n">dataset_name</span> <span class="o">=</span> <span class="s1">&#39;MIT&#39;</span>      <span class="c1">### NASA; MIT; Tarascon Coin.</span>
</pre></div>
</div>
</div>
<div class="nbinput docutils container">
<div class="prompt highlight-none notranslate"><div class="highlight"><pre><span></span>[ ]:
</pre></div>
</div>
<div class="input_area highlight-python notranslate"><div class="highlight"><pre>
<span></span><span class="c1"># Dataset creation:</span>
<span class="k">try</span><span class="p">:</span>
    <span class="n">os</span><span class="o">.</span><span class="n">chdir</span><span class="p">(</span><span class="n">dataset_path_dict</span><span class="p">[</span><span class="n">dataset_name</span><span class="p">])</span>
<span class="k">except</span><span class="p">:</span>
    <span class="k">raise</span> <span class="ne">FileNotFoundError</span><span class="p">(</span><span class="s2">&quot;Current directory: &quot;</span><span class="p">,</span> <span class="n">os</span><span class="o">.</span><span class="n">getcwd</span><span class="p">())</span>

<span class="n">files</span> <span class="o">=</span> <span class="n">os</span><span class="o">.</span><span class="n">listdir</span><span class="p">()</span>    <span class="c1"># All files in the folder</span>
<span class="n">file_list</span> <span class="o">=</span> <span class="p">[]</span>          <span class="c1"># List with the valid files</span>

<span class="k">for</span> <span class="n">file_name</span> <span class="ow">in</span> <span class="n">files</span><span class="p">:</span>
    <span class="n">match</span> <span class="o">=</span> <span class="n">re</span><span class="o">.</span><span class="n">search</span><span class="p">(</span><span class="sa">r</span><span class="s1">&#39;B\d</span><span class="si">{4}</span><span class="s1">.txt&#39;</span><span class="p">,</span> <span class="n">file_name</span><span class="p">)</span> <span class="c1"># Only take into acount</span>
                                                <span class="c1"># the battery files</span>
    <span class="k">if</span> <span class="n">match</span> <span class="o">==</span> <span class="kc">None</span><span class="p">:</span>
        <span class="k">continue</span>
    <span class="k">else</span><span class="p">:</span>
        <span class="n">file_list</span><span class="o">.</span><span class="n">append</span><span class="p">(</span><span class="n">file_name</span><span class="p">)</span>
<span class="n">file_list</span><span class="o">.</span><span class="n">sort</span><span class="p">()</span>


<span class="n">ignore</span> <span class="o">=</span> <span class="n">ignore_dict</span><span class="p">[</span><span class="n">dataset_name</span><span class="p">]</span>
<span class="n">train</span> <span class="o">=</span> <span class="n">train_dict</span><span class="p">[</span><span class="n">dataset_name</span><span class="p">]</span>

<span class="c1"># Training files:</span>
<span class="n">Train_list</span> <span class="o">=</span> <span class="p">[]</span>
<span class="k">for</span> <span class="n">file_name</span> <span class="ow">in</span> <span class="n">file_list</span><span class="p">:</span>
    <span class="k">if</span> <span class="n">file_name</span> <span class="ow">not</span> <span class="ow">in</span> <span class="n">train</span><span class="p">:</span>
        <span class="k">continue</span>
    <span class="k">else</span><span class="p">:</span>
        <span class="k">with</span> <span class="nb">open</span><span class="p">(</span><span class="n">file_name</span><span class="p">,</span> <span class="s1">&#39;rb&#39;</span><span class="p">)</span> <span class="k">as</span> <span class="n">f</span><span class="p">:</span>
            <span class="n">Battery</span> <span class="o">=</span> <span class="n">pickle</span><span class="o">.</span><span class="n">load</span><span class="p">(</span><span class="n">f</span><span class="p">)</span>

        <span class="n">Train_list</span><span class="o">.</span><span class="n">append</span><span class="p">(</span><span class="n">Battery</span><span class="p">)</span>

<span class="c1"># Validation files:</span>
<span class="n">Valid_list</span> <span class="o">=</span> <span class="p">[]</span>
<span class="k">for</span> <span class="n">file_name</span> <span class="ow">in</span> <span class="n">file_list</span><span class="p">:</span>
    <span class="k">if</span> <span class="p">(</span><span class="n">file_name</span> <span class="ow">not</span> <span class="ow">in</span> <span class="n">train</span><span class="p">)</span> <span class="ow">and</span> <span class="p">(</span><span class="n">file_name</span> <span class="ow">not</span> <span class="ow">in</span> <span class="n">ignore</span><span class="p">):</span>
        <span class="k">with</span> <span class="nb">open</span><span class="p">(</span><span class="n">file_name</span><span class="p">,</span> <span class="s1">&#39;rb&#39;</span><span class="p">)</span> <span class="k">as</span> <span class="n">f</span><span class="p">:</span>
            <span class="n">Battery</span> <span class="o">=</span> <span class="n">pickle</span><span class="o">.</span><span class="n">load</span><span class="p">(</span><span class="n">f</span><span class="p">)</span>
        <span class="n">Valid_list</span><span class="o">.</span><span class="n">append</span><span class="p">(</span><span class="n">Battery</span><span class="p">)</span>

<span class="n">os</span><span class="o">.</span><span class="n">chdir</span><span class="p">(</span><span class="s1">&#39;../../../../&#39;</span><span class="p">)</span>

<span class="c1"># wn datasets:</span>
<span class="n">train_dataset</span> <span class="o">=</span> <span class="n">wn</span><span class="o">.</span><span class="n">Torch_Dataset_LSTM</span><span class="p">(</span>
    <span class="n">Train_list</span><span class="p">,</span> <span class="n">DELTA</span><span class="p">,</span> <span class="n">LSTM_version</span><span class="p">,</span> <span class="n">print_bool</span><span class="o">=</span><span class="kc">True</span><span class="p">,</span> <span class="n">time_step</span><span class="o">=</span><span class="n">time_step</span><span class="p">,</span>
    <span class="n">fixed_len</span><span class="o">=</span><span class="n">fixed_len</span><span class="p">,</span> <span class="n">norm_type</span><span class="o">=</span><span class="n">norm_type</span><span class="p">,</span> <span class="n">adimensionalize</span><span class="o">=</span><span class="n">adimensionalize</span><span class="p">,</span>
    <span class="n">cycle_lim</span><span class="o">=</span><span class="n">cycle_lim</span>
    <span class="p">)</span>

<span class="n">valid_dataset</span> <span class="o">=</span> <span class="n">wn</span><span class="o">.</span><span class="n">Torch_Dataset_LSTM</span><span class="p">(</span>
    <span class="n">Valid_list</span><span class="p">,</span> <span class="n">DELTA</span><span class="p">,</span> <span class="n">LSTM_version</span><span class="p">,</span> <span class="n">print_bool</span><span class="o">=</span><span class="kc">True</span><span class="p">,</span>
    <span class="n">time_step</span><span class="o">=</span><span class="n">train_dataset</span><span class="o">.</span><span class="n">time_step</span><span class="p">,</span> <span class="n">norm</span><span class="o">=</span><span class="n">train_dataset</span><span class="o">.</span><span class="n">norm</span><span class="p">,</span>
    <span class="c1"># time_step and norm are carried from the training dataset</span>
    <span class="n">fixed_len</span><span class="o">=</span><span class="n">fixed_len</span><span class="p">,</span> <span class="n">adimensionalize</span><span class="o">=</span><span class="n">adimensionalize</span><span class="p">,</span> <span class="n">cycle_lim</span><span class="o">=</span><span class="n">cycle_lim</span>
    <span class="p">)</span>


<span class="c1"># Loaders:</span>
<span class="k">if</span> <span class="n">train_dataset</span><span class="o">.</span><span class="n">fixed_len</span> <span class="ow">is</span> <span class="kc">None</span><span class="p">:</span>
    <span class="n">train_loader</span> <span class="o">=</span> <span class="n">DataLoader</span><span class="p">(</span><span class="n">dataset</span><span class="o">=</span><span class="n">train_dataset</span><span class="p">,</span> <span class="n">batch_size</span><span class="o">=</span><span class="mi">1</span><span class="p">,</span>
                                <span class="n">shuffle</span><span class="o">=</span><span class="kc">True</span><span class="p">,</span> <span class="n">num_workers</span><span class="o">=</span><span class="mi">0</span><span class="p">)</span>
    <span class="n">sim_train_loader</span> <span class="o">=</span> <span class="n">DataLoader</span><span class="p">(</span><span class="n">dataset</span><span class="o">=</span><span class="n">train_dataset</span><span class="p">,</span> <span class="n">batch_size</span><span class="o">=</span><span class="mi">1</span><span class="p">,</span>
                                  <span class="n">shuffle</span><span class="o">=</span><span class="kc">False</span><span class="p">)</span>
    <span class="n">valid_loader</span> <span class="o">=</span> <span class="n">DataLoader</span><span class="p">(</span><span class="n">dataset</span><span class="o">=</span><span class="n">valid_dataset</span><span class="p">,</span> <span class="n">batch_size</span><span class="o">=</span><span class="mi">1</span><span class="p">,</span>
                                <span class="n">shuffle</span><span class="o">=</span><span class="kc">False</span><span class="p">,</span> <span class="n">num_workers</span><span class="o">=</span><span class="mi">0</span><span class="p">)</span>
<span class="k">else</span><span class="p">:</span>
    <span class="n">train_loader</span> <span class="o">=</span> <span class="n">DataLoader</span><span class="p">(</span><span class="n">dataset</span><span class="o">=</span><span class="n">train_dataset</span><span class="p">,</span> <span class="n">batch_size</span><span class="o">=</span><span class="n">batch_size</span><span class="p">,</span>
                                <span class="n">shuffle</span><span class="o">=</span><span class="kc">True</span><span class="p">,</span> <span class="n">num_workers</span><span class="o">=</span><span class="mi">0</span><span class="p">)</span>
    <span class="n">sim_train_loader</span> <span class="o">=</span> <span class="n">DataLoader</span><span class="p">(</span><span class="n">dataset</span><span class="o">=</span><span class="n">train_dataset</span><span class="p">,</span>
                                  <span class="n">batch_size</span><span class="o">=</span><span class="nb">len</span><span class="p">(</span><span class="n">train_dataset</span><span class="p">),</span> <span class="n">shuffle</span><span class="o">=</span><span class="kc">False</span><span class="p">)</span>
    <span class="n">valid_loader</span> <span class="o">=</span> <span class="n">DataLoader</span><span class="p">(</span><span class="n">dataset</span><span class="o">=</span><span class="n">valid_dataset</span><span class="p">,</span> <span class="n">batch_size</span><span class="o">=</span><span class="nb">len</span><span class="p">(</span><span class="n">valid_dataset</span><span class="p">),</span>
                              <span class="n">shuffle</span><span class="o">=</span><span class="kc">False</span><span class="p">,</span> <span class="n">num_workers</span><span class="o">=</span><span class="mi">0</span><span class="p">)</span>
</pre></div>
</div>
</div>
<div class="nboutput nblast docutils container">
<div class="prompt empty docutils container">
</div>
<div class="output_area docutils container">
<div class="highlight"><pre>
2.6253445148468018
B0001
130
B0000
B0002
B0003
B0004
B0005
B0006
B0007
B0008
B0009
B0010
B0011
B0012
B0013
B0014
7028
</pre></div></div>
</div>
<div class="nbinput docutils container">
<div class="prompt highlight-none notranslate"><div class="highlight"><pre><span></span>[ ]:
</pre></div>
</div>
<div class="input_area highlight-python notranslate"><div class="highlight"><pre>
<span></span><span class="c1"># Preview of the model&#39;s performance as is:</span>

<span class="n">simulate</span><span class="p">(</span><span class="n">sim_train_loader</span><span class="p">,</span> <span class="n">Model</span><span class="p">,</span> <span class="n">device</span><span class="o">=</span><span class="n">device</span><span class="p">,</span> <span class="n">denormalize</span><span class="o">=</span><span class="kc">False</span><span class="p">,</span> <span class="n">report</span><span class="o">=</span><span class="kc">True</span><span class="p">)</span>
<span class="n">simulate</span><span class="p">(</span><span class="n">valid_loader</span><span class="p">,</span> <span class="n">Model</span><span class="p">,</span> <span class="n">device</span><span class="o">=</span><span class="n">device</span><span class="p">,</span> <span class="n">denormalize</span><span class="o">=</span><span class="kc">False</span><span class="p">,</span> <span class="n">report</span><span class="o">=</span><span class="kc">True</span><span class="p">)</span>
<span class="c1"># denormalize = False is important because normalization is done by the model</span>
<span class="c1"># since we are using wn models.</span>
</pre></div>
</div>
</div>
<div class="nboutput docutils container">
<div class="prompt empty docutils container">
</div>
<div class="output_area docutils container">
<img alt="../_images/sphinx_normalisation_training_9_0.png" src="../_images/sphinx_normalisation_training_9_0.png" />
</div>
</div>
<div class="nboutput nblast docutils container">
<div class="prompt empty docutils container">
</div>
<div class="output_area docutils container">
<img alt="../_images/sphinx_normalisation_training_9_1.png" src="../_images/sphinx_normalisation_training_9_1.png" />
</div>
</div>
<div class="nbinput docutils container">
<div class="prompt highlight-none notranslate"><div class="highlight"><pre><span></span>[ ]:
</pre></div>
</div>
<div class="input_area highlight-python notranslate"><div class="highlight"><pre>
<span></span><span class="c1"># Now changing the model&#39;s norm to the dataset&#39;s:</span>
<span class="n">Model</span><span class="o">.</span><span class="n">change_norm</span><span class="p">(</span><span class="n">train_dataset</span><span class="o">.</span><span class="n">norm</span><span class="p">)</span>
<span class="n">Model</span> <span class="o">=</span> <span class="n">Model</span><span class="o">.</span><span class="n">to</span><span class="p">(</span><span class="n">device</span><span class="p">)</span>    <span class="c1"># just to make sure</span>

<span class="c1"># Evaluating it&#39;s performance now:</span>
<span class="n">simulate</span><span class="p">(</span><span class="n">sim_train_loader</span><span class="p">,</span> <span class="n">Model</span><span class="p">,</span> <span class="n">device</span><span class="o">=</span><span class="n">device</span><span class="p">,</span> <span class="n">denormalize</span><span class="o">=</span><span class="kc">False</span><span class="p">,</span> <span class="n">report</span><span class="o">=</span><span class="kc">True</span><span class="p">)</span>
<span class="n">simulate</span><span class="p">(</span><span class="n">valid_loader</span><span class="p">,</span> <span class="n">Model</span><span class="p">,</span> <span class="n">device</span><span class="o">=</span><span class="n">device</span><span class="p">,</span> <span class="n">denormalize</span><span class="o">=</span><span class="kc">False</span><span class="p">,</span> <span class="n">report</span><span class="o">=</span><span class="kc">True</span><span class="p">)</span>
</pre></div>
</div>
</div>
<div class="nboutput docutils container">
<div class="prompt empty docutils container">
</div>
<div class="output_area docutils container">
<img alt="../_images/sphinx_normalisation_training_10_0.png" src="../_images/sphinx_normalisation_training_10_0.png" />
</div>
</div>
<div class="nboutput nblast docutils container">
<div class="prompt empty docutils container">
</div>
<div class="output_area docutils container">
<img alt="../_images/sphinx_normalisation_training_10_1.png" src="../_images/sphinx_normalisation_training_10_1.png" />
</div>
</div>
<div class="nbinput docutils container">
<div class="prompt highlight-none notranslate"><div class="highlight"><pre><span></span>[ ]:
</pre></div>
</div>
<div class="input_area highlight-python notranslate"><div class="highlight"><pre>
<span></span><span class="c1"># Training loop:</span>
<span class="n">Nb_Epochs</span> <span class="o">=</span> <span class="mi">25</span>          <span class="c1">###</span>
<span class="n">Learning_Rate</span> <span class="o">=</span> <span class="mf">1e-5</span>    <span class="c1">###</span>


<span class="n">Train_info</span><span class="p">,</span> <span class="n">_</span><span class="p">,</span> <span class="n">_</span><span class="p">,</span> <span class="n">date</span> <span class="o">=</span> <span class="n">Train</span><span class="p">(</span>
    <span class="n">train_loader</span><span class="p">,</span> <span class="n">valid_loader</span><span class="p">,</span> <span class="n">Model</span><span class="p">,</span> <span class="n">Nb_Epochs</span><span class="p">,</span> <span class="n">plot_bool</span><span class="o">=</span><span class="kc">True</span><span class="p">,</span>
    <span class="n">LR</span><span class="o">=</span><span class="n">Learning_Rate</span><span class="p">,</span> <span class="n">report</span><span class="o">=</span><span class="kc">True</span><span class="p">,</span> <span class="n">print_bool</span><span class="o">=</span><span class="kc">True</span><span class="p">,</span> <span class="n">device</span><span class="o">=</span><span class="n">device</span><span class="p">,</span>
    <span class="n">remove_bool</span><span class="o">=</span><span class="kc">True</span>
    <span class="p">)</span>

<span class="c1"># updating the Model&#39;s norm attribute after training in case report=False:</span>
<span class="n">Model</span><span class="o">.</span><span class="n">update_norm</span><span class="p">()</span>

<span class="c1"># Best epoch&#39;s performance:</span>
<span class="n">simulate</span><span class="p">(</span><span class="n">sim_train_loader</span><span class="p">,</span> <span class="n">Model</span><span class="p">,</span> <span class="n">denormalize</span><span class="o">=</span><span class="kc">False</span><span class="p">,</span> <span class="n">device</span><span class="o">=</span><span class="n">device</span><span class="p">,</span> <span class="n">report</span><span class="o">=</span><span class="kc">True</span><span class="p">)</span>
<span class="n">simulate</span><span class="p">(</span><span class="n">valid_loader</span><span class="p">,</span> <span class="n">Model</span><span class="p">,</span> <span class="n">denormalize</span><span class="o">=</span><span class="kc">False</span><span class="p">,</span> <span class="n">device</span><span class="o">=</span><span class="n">device</span><span class="p">,</span> <span class="n">report</span><span class="o">=</span><span class="kc">True</span><span class="p">)</span>
</pre></div>
</div>
</div>
<div class="nboutput docutils container">
<div class="prompt empty docutils container">
</div>
<div class="output_area docutils container">
<div class="highlight"><pre>
1 . Training loss:  tensor(0.0007)
1 . Validation loss:  tensor(0.0012)
2 . Training loss:  tensor(0.0006)
2 . Validation loss:  tensor(0.0010)
3 . Training loss:  tensor(0.0005)
3 . Validation loss:  tensor(0.0009)
4 . Training loss:  tensor(0.0004)
4 . Validation loss:  tensor(0.0007)
5 . Training loss:  tensor(0.0003)
5 . Validation loss:  tensor(0.0006)
6 . Training loss:  tensor(0.0002)
6 . Validation loss:  tensor(0.0005)
7 . Training loss:  tensor(0.0001)
7 . Validation loss:  tensor(0.0004)
8 . Training loss:  tensor(0.0001)
8 . Validation loss:  tensor(0.0004)
9 . Training loss:  tensor(6.6038e-05)
9 . Validation loss:  tensor(0.0003)
10 . Training loss:  tensor(4.7418e-05)
10 . Validation loss:  tensor(0.0003)
11 . Training loss:  tensor(4.0387e-05)
11 . Validation loss:  tensor(0.0003)
12 . Training loss:  tensor(3.7128e-05)
12 . Validation loss:  tensor(0.0003)
13 . Training loss:  tensor(3.4877e-05)
13 . Validation loss:  tensor(0.0002)
14 . Training loss:  tensor(3.2757e-05)
14 . Validation loss:  tensor(0.0002)
15 . Training loss:  tensor(3.0772e-05)
15 . Validation loss:  tensor(0.0002)
16 . Training loss:  tensor(2.8898e-05)
16 . Validation loss:  tensor(0.0002)
17 . Training loss:  tensor(2.7337e-05)
17 . Validation loss:  tensor(0.0002)
18 . Training loss:  tensor(2.5665e-05)
18 . Validation loss:  tensor(0.0002)
19 . Training loss:  tensor(2.4162e-05)
19 . Validation loss:  tensor(0.0002)
20 . Training loss:  tensor(2.2711e-05)
20 . Validation loss:  tensor(0.0002)
21 . Training loss:  tensor(2.1354e-05)
21 . Validation loss:  tensor(0.0002)
22 . Training loss:  tensor(2.0124e-05)
22 . Validation loss:  tensor(0.0002)
23 . Training loss:  tensor(1.8994e-05)
23 . Validation loss:  tensor(0.0002)
24 . Training loss:  tensor(1.8024e-05)
24 . Validation loss:  tensor(0.0002)
25 . Training loss:  tensor(1.7028e-05)
25 . Validation loss:  tensor(0.0002)
</pre></div></div>
</div>
<div class="nboutput docutils container">
<div class="prompt empty docutils container">
</div>
<div class="output_area docutils container">
<img alt="../_images/sphinx_normalisation_training_11_1.png" src="../_images/sphinx_normalisation_training_11_1.png" />
</div>
</div>
<div class="nboutput docutils container">
<div class="prompt empty docutils container">
</div>
<div class="output_area docutils container">
<div class="highlight"><pre>
Best validation error:  25
</pre></div></div>
</div>
<div class="nboutput docutils container">
<div class="prompt empty docutils container">
</div>
<div class="output_area docutils container">
<img alt="../_images/sphinx_normalisation_training_11_3.png" src="../_images/sphinx_normalisation_training_11_3.png" />
</div>
</div>
<div class="nboutput nblast docutils container">
<div class="prompt empty docutils container">
</div>
<div class="output_area docutils container">
<img alt="../_images/sphinx_normalisation_training_11_4.png" src="../_images/sphinx_normalisation_training_11_4.png" />
</div>
</div>
<div class="nbinput docutils container">
<div class="prompt highlight-none notranslate"><div class="highlight"><pre><span></span>[ ]:
</pre></div>
</div>
<div class="input_area highlight-python notranslate"><div class="highlight"><pre>
<span></span><span class="c1"># Calculating the model&#39;s error for each battery separately:</span>
<span class="n">Load_Save</span><span class="p">(</span><span class="n">date</span><span class="p">,</span> <span class="n">device</span><span class="o">=</span><span class="n">device</span><span class="p">,</span> <span class="n">dataset_name</span><span class="o">=</span><span class="n">dataset_name</span><span class="p">,</span> <span class="n">denormalize_bool</span><span class="o">=</span><span class="kc">False</span><span class="p">)</span>

<span class="k">if</span> <span class="n">dataset_name</span> <span class="o">==</span> <span class="s1">&#39;MIT&#39;</span><span class="p">:</span>
    <span class="n">Load_Save_v2</span><span class="p">(</span><span class="n">date</span><span class="p">,</span> <span class="n">dataset_name</span><span class="p">,</span> <span class="n">device</span><span class="o">=</span><span class="n">device</span><span class="p">,</span>
                 <span class="n">time_step</span><span class="o">=</span><span class="n">train_dataset</span><span class="o">.</span><span class="n">time_step</span><span class="p">,</span> <span class="n">norm_test</span><span class="o">=</span><span class="s1">&#39;Model&#39;</span><span class="p">,</span>
                 <span class="n">cycle_lim</span><span class="o">=</span><span class="n">cycle_lim</span><span class="p">,</span> <span class="n">denormalize_bool</span><span class="o">=</span><span class="kc">False</span><span class="p">)</span>
</pre></div>
</div>
</div>
<div class="nboutput nblast docutils container">
<div class="prompt empty docutils container">
</div>
<div class="output_area docutils container">
<div class="highlight"><pre>
B0000
280
B0001
130
B0002
426
B0003
313
B0004
427
B0005
465
B0006
457
B0007
522
B0008
829
B0009
951
B0010
534
B0011
461
B0012
432
B0013
460
B0014
471
B0000.txt
B0001.txt (used in training)
B0002.txt
B0003.txt
B0004.txt
B0005.txt
B0006.txt
B0007.txt
B0008.txt
B0009.txt
B0010.txt
B0011.txt
B0012.txt
B0013.txt
B0014.txt
B0000.txt
B0001.txt (used in training)
B0002.txt
B0003.txt
B0004.txt
B0005.txt
B0006.txt
B0007.txt
B0008.txt
B0009.txt
B0010.txt
B0011.txt
B0012.txt
B0013.txt
B0014.txt
&lt;class &#39;type&#39;&gt;
B0000
280
B0001
130
B0002
426
B0003
313
B0004
427
B0005
465
B0006
457
B0007
522
B0008
829
B0009
951
B0010
534
B0011
461
B0012
432
B0013
460
B0014
471
B0015
126
B0016
382
B0017
477
B0018
466
B0019
443
B0020
487
B0021
475
B0022
501
B0023
509
B0024
205
B0025
152
B0026
186
B0027
454
B0028
494
B0029
483
B0030
465
B0031
477
B0032
506
B0033
507
B0034
485
B0035
449
B0036
524
B0037
468
B0038
455
B0039
449
B0040
479
B0041
416
B0042
450
B0043
447
B0044
444
B0045
470
B0046
420
B0047
676
</pre></div></div>
</div>
</div>


              </div>
              
              
              <div class='prev-next-bottom'>
                
    <a class='left-prev' id="prev-link" href="training_colab.html" title="previous page"><strong>Training Colab</strong></a>
    <a class='right-next' id="next-link" href="lstm_chemistry_training.html" title="next page"><strong>LSTM Chemistry Training Colab</strong></a>

              </div>
              
          </main>
          

      </div>
    </div>
  
  <script src="../_static/js/index.1c5a1a01449ed65a7b51.js"></script>

  <footer class="footer mt-5 mt-md-0">
  <div class="container">
    
    <div class="footer-item">
      <p class="copyright">
    &copy; Copyright 2022, Antonio ROCHA AZEVEDO.<br/>
</p>
    </div>
    
    <div class="footer-item">
      <p class="sphinx-version">
Created using <a href="http://sphinx-doc.org/">Sphinx</a> 4.0.2.<br/>
</p>
    </div>
    
  </div>
</footer>
  </body>
</html>